// Sorting an unsigned int array
//   Simple bubble sort written in C:    gcc 45_Sort.c 45_Sort1.c
//   LSB radix sort written in C:        gcc 45_Sort.c 45_Sort2.c
//   LSB radix sort written in assebly:  gcc 45_Sort.c 45_Sort2.s -no-pie

#include<stdio.h>
#include<stdlib.h>

#define NumOfValues 100000000
#define BigestValue 1000000000

void Sort(unsigned int *A, int N); 

unsigned int* Create_Array(int ArraySize, unsigned int Max){
  /*** A function create an array of 'ArraySize' unsigned int values not greater then 'Max'. It returns by the address of the array. ***/ 
  int i;
  unsigned int* Array = (unsigned int*)malloc(ArraySize*sizeof(unsigned int));
  for(i=0;i<ArraySize;i++)
    Array[i]=rand()%Max;
  return Array;
  }

void PrintArray(unsigned int *A, int N){
  /*** A procedure to print an array ('A') of 'N' unsigned int values. ***/
  int i;
  for(i=0;i<N;i++) 
    printf("%d ",A[i]);
  printf("\n");
  }

int main(){
  unsigned int *MyArray;
  MyArray = Create_Array(NumOfValues,BigestValue);
  //PrintArray(MyArray,NumOfValues);
  
  Sort(MyArray,NumOfValues);

  //PrintArray(MyArray,NumOfValues);
  free(MyArray);
  return EXIT_SUCCESS;
  }
